//+------------------------------------------------------------------+
//|                                                     Dolly1.mq4 |
//|                                      Copyright  2007, Dolly. |
//|                                     http://www.forex-tsd.com/dolly |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Dolly."
#property link      "http://www.forex-tsd.com/dolly"


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//---- input parameters
extern string    Version="Dolly 1";
extern int       MagicNumber=256894;
extern string    MONEY_MANAGEMENT="MONEY MANAGEMENT";
extern bool      UseMM=true;
extern double    Risk=0.1;
extern double    MinLots=0.1;
extern double    MaxLots=100.0;
extern bool      Micro=false;
extern double    FixedLots=0.1;
extern string    ORDER_SETTING="ORDER SETTING";
extern int       TakeProfit=40;
extern int       StopLoss=30;
extern string    PROFIT_PROTECT="PROFIT PROTECT SETTING";
extern int       ProfitProtectStart=30;
extern int       ProtectProfit=10;
extern int       OverProtect=30;
extern string    TRADING_HOURS="TRADING HOURS";
extern int       StartHour=8;
extern int       EndHour=20;
extern bool      SignalAlert=false;
extern bool      UseOpen=false;
extern bool      UsePivot=true;

//---- GlobalVariable
double high,low,close,pivot,buystart,sellstart,tp,sl,ticket,open;
int ticketID,DayOfLastBuyTrade,DayOfLastSellTrade,lastsignal,buy,sell;
string Website="www.fxtsd.com/dolly";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
 
   ticketID=NULL;
   tp=TakeProfit*Point;
   sl=StopLoss*Point;
   setPivot();
   MagicNumber=OrderMagicNumber();
  
   

   


   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start(){
 Comment("\n",Version,"\n" , Website,"\n", AccountCompany(),"\nAccount Number: ", AccountNumber(), "\nName: ", AccountName(), "\nServer: ", AccountServer(),"\nBalance: ", AccountBalance());

      if(OrdersTotal()>0){
      for(int i=0;i<=OrdersTotal()-1;i++){   
         OrderSelect(i, SELECT_BY_POS);
        if (OrderMagicNumber() == MagicNumber){
         if(OrderType()==0 || OrderType()==1){
         
            if(((MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice()) / MarketInfo(Symbol(),MODE_POINT) )>=ProfitProtectStart && OrderType()==0 && ticketID!=OrderTicket()){
               OrderModify(OrderTicket(),OrderOpenPrice(),buystart+(Point*ProtectProfit),OrderTakeProfit(),0,Blue);
               ticketID=OrderTicket();
           }
            else if(((OrderOpenPrice() - MarketInfo(Symbol(),MODE_ASK)) / MarketInfo(Symbol(),MODE_POINT))>=ProfitProtectStart && OrderType()==1 && ticketID!=OrderTicket()){
               OrderModify(OrderTicket(),OrderOpenPrice(),sellstart-(Point*ProtectProfit),OrderTakeProfit(),0,Blue);
               ticketID=OrderTicket();
 }
  }
 }
  } 
 }
    if(OrdersTotal()>0){
      for(int j=0;j<=OrdersTotal()-1;j++){   
         OrderSelect(j, SELECT_BY_POS);
        if (OrderMagicNumber() == MagicNumber){
         if(OrderType()==0 || OrderType()==1){
          if (((MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice()) / MarketInfo(Symbol(),MODE_POINT) )>=OverProtect && iRSI(NULL,0,3,PRICE_CLOSE,0)>90 && OrderType()==0) {
             OrderClose(OrderTicket(),OrderLots(),Bid,2,Violet);//Buy case
             }
             if (((OrderOpenPrice() - MarketInfo(Symbol(),MODE_ASK)) / MarketInfo(Symbol(),MODE_POINT))>=OverProtect && iRSI(NULL,0,3,PRICE_CLOSE,0)<10 && OrderType()==1){
             OrderClose(OrderTicket(),OrderLots(),Ask,2,Violet);}//Sell case
             }
             }
             }
              }
     


   if(Hour()>=StartHour && Minute()>=0 && Hour()<=EndHour){
      setPivot();
      if(OrdersTotal()>0){
      for(int k=0;k<=OrdersTotal()-1;k++){   
         OrderSelect(k, SELECT_BY_POS);
        if (OrderMagicNumber() != MagicNumber){
         if(OrderType()==0 || OrderType()==1 || OrderType()==2 || OrderType()==3 || OrderType()==4 || OrderType()==5){
      sendOrder();
       }
        }
         }
          }
          if (OrdersTotal()==0){
          sendOrder();
          }
     
   }
   
   if(Hour()==EndHour && Minute()>=0 && OrdersTotal()>0){
      CloseAllOrder();
       }
       
   }
   
   



void setPivot(){

   high=iHigh(NULL,PERIOD_D1,1);
   low=iLow(NULL,PERIOD_D1,1);
   close=iClose(NULL,PERIOD_D1,1);
   pivot=NormalizeDouble((high+low+close)/3,4);
   open=iOpen(NULL,PERIOD_D1,0);
  if (UseOpen){ buystart=open+0.0020;
   sellstart=pivot-0.0020;}
   if (UsePivot){buystart=pivot+0.0020;sellstart=pivot-0.0020;}
  
}

double getLotSize(){

   double lot;

   if(UseMM){
      if(!Micro){
         lot = NormalizeDouble((Risk*AccountBalance())/1000,1);
         if(lot>MaxLots){lot=MaxLots;}
         else if(lot<MinLots){lot=MinLots;}
      }
      else{
         lot = NormalizeDouble((Risk*AccountBalance())/1000,2);
         if(lot>MaxLots){lot=MaxLots;}
         else if(lot<MinLots){lot=MinLots;}
      }
      
      return(lot);
   }
   else{
      return(FixedLots);
   }
}

void sendOrder(){

double Trend=iCustom(Symbol(),0,"BBands-1",20,2,1,0,1);
double Trend1=iCustom(Symbol(),0,"BBands-1",20,2,1,1,1);
if (iMomentum(NULL,0,14,PRICE_CLOSE,0) > 100 && iRSI(NULL,0,14,PRICE_CLOSE,0)>50 && Trend>0){buy=1;sell=0;}
if ( iMomentum(NULL,0,14,PRICE_CLOSE,0) < 100 && iRSI(NULL,0,14,PRICE_CLOSE,0)<50 && Trend1>0){buy=0;sell=1;}




      if(TimeDayOfYear(TimeCurrent())!=DayOfLastBuyTrade && Ask==buystart && buy==1){
         ticket=OrderSend(Symbol(),OP_BUY,getLotSize(),Ask,2,buystart-sl,buystart+tp,"Dolly",MagicNumber,0,CLR_NONE);     
        DayOfLastBuyTrade=TimeDayOfYear(TimeCurrent());
        if(ticket > 0)
         {
           if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) {
               Print("BUY order opened : ", OrderOpenPrice());
               if (SignalAlert){Alert("Dolly Opened Buy on ",Symbol()," at ",OrderOpenPrice());}}
         }
       else 
           Print("Error opening BUY order : ", GetLastError()); 
          }
      
     
      
      else if(TimeDayOfYear(TimeCurrent())!=DayOfLastSellTrade && Bid==sellstart && sell==1){
         ticket=OrderSend(Symbol(),OP_SELL,getLotSize(),Bid,2,sellstart+sl,sellstart-tp,"Dolly",MagicNumber,0,CLR_NONE);
         DayOfLastSellTrade=TimeDayOfYear(TimeCurrent());
         if(ticket > 0)
         {
           if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)){ 
               Print("SELL order opened : ", OrderOpenPrice());
               if (SignalAlert){Alert("Dolly Opened Sell on ",Symbol()," at ",OrderOpenPrice());}}
         }
       else 
           Print("Error opening SELL order : ", GetLastError()); 
          }
          
      
     
      else{}

        
       
}



void CloseAllOrder()
{
      int total  = OrdersTotal();
      for (int cnt = OrdersTotal()-1 ; cnt < total ; cnt++)
      {
         OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
         if (OrderMagicNumber() == MagicNumber) {
            if(OrderType()==OP_BUY){
             OrderClose(OrderTicket(),OrderLots(),Bid,2,Violet);}
           
            if(OrderType()==OP_SELL) {  
             OrderClose(OrderTicket(),OrderLots(),Ask,2,Violet);}
            
             if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT || OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)  { 
             OrderDelete(OrderTicket());}
      }
  }
  
}

